<template>
  <BasicModal
    v-bind="$attrs"
    @register="register"
    title="请选择参与人"
    @ok="handleSubmit"
  >
    <div :class="'pt-3px pr-3px '+ prefixCls">
      <BasicForm @register="registerForm" :model="modelRef" >
        <template #tree="{ model, field }">
          <TreeSelect
            v-model:value="model[field]"
            placeholder="请选择参与人"
            tree-checkable
            :tree-data="treeData"
            tree-node-filter-prop="title"
          >
            <template #title="{ value, title, avatar,children }">
<!--              <span v-if="children.length>0">{{children.length }}人</span>-->
<!--              <Avatar v-if="children.length<1" :size="16">%</Avatar>-->
<!--              <Avatar v-else :src="avatar" :size="24"></Avatar>-->
              <Avatar :src="avatar" :size="24" style="background-color: transparent">
                <template #icon><FolderFilled style="color: #00ccee;fontSize:20px" /></template>
              </Avatar>
              {{ title+'---'+value }}

<!--              <template v-else>{{ title }}</template>-->
            </template>
          </TreeSelect>
        </template>
      </BasicForm>
    </div>
  </BasicModal>
</template>
<script lang="tsx" setup>
import {ref} from 'vue';
import {BasicModal, useModalInner} from '@/components/Modal';
import {BasicForm, FormSchema, useForm} from '@/components/Form';
import {TreeSelect,Avatar} from 'ant-design-vue';
import {treeOptionsListApi} from "@/api/schedule/personnel";
import { FolderFilled } from '@ant-design/icons-vue';
const prefixCls = 'new-schedule';
// const props = defineProps({
//   userData: {type: Object},
// });
const modelRef = ref({});
const schemas: FormSchema[]= [
  {
    field: 'personal',
    // component: 'ApiTreeSelect',
    label: '参与人',
    // helpMessage: ['ApiTreeSelect组件', '使用接口提供的数据生成选项'],
    // required: true,
    // componentProps: {
    //   api: treeOptionsListApi,
    //   treeCheckable: true,
    //   treeIcon: true,
    //   resultField: 'list',
    //   onChange: (e, v) => {
    //     console.log('ApiTreeSelect====>:', e, v);
    //   },
    // },
    slot: 'tree',
    colProps: {
      span: 24,
      // style: {
      //   width: '100%',
      // },
    },
  },
]

const [
  registerForm,
  {

    setFieldsValue, updateSchema, resetFields, validate,getFieldsValue
    // getFieldsValue: getFieldsValueGroup,
    // setFieldsValue,
  },
  // {
  //   // setFieldsValue,
  //   // setProps
  // },
] = useForm({
  layout: 'vertical',
  // labelWidth: 100,
  schemas,
  showActionButtonGroup: false,
  actionColOptions: {
    span: 24,
  },
});



const [register,{ setModalProps, closeModal }] = useModalInner((data) => {
  setModalProps({ canFullscreen: false,height:100 });
  Logger.log('useModalInner data...', data);
  data && onDataReceive(data);
});



function onDataReceive(data) {
  console.log('Data Received', data);
  // 方式1;
  setFieldsValue({
    personal: data.data,
  });

  // // 方式2
  // modelRef.value = {field2: data.data, field1: data.info};


  // setProps({
  //   model:{ field2: data.data, field1: data.info }
  // })
}

let treeData = ref([]);
getTreeData();
async function getTreeData() {
  try {
    const data = await treeOptionsListApi();
    treeData.value = data?.list || [];
    Logger.log('treeOptionsListApi', treeData);
  } catch (e) {
    Logger.error(e);
  } finally {

  }
}



const emit = defineEmits(['submitOk','register']);
function handleSubmit() {
  try {
    let selectedValues = getFieldsValue()['personal'];
    // Logger.log('selectedValues...',selectedValues);
    if (!selectedValues?.length) return;
    let selectedTreeData = getSelectedTreeData(treeData.value,selectedValues);
    Logger.log('...selectedTreeData...',selectedTreeData);
    emit('submitOk', selectedTreeData);

  } catch(e){
    Logger.log(e)
  } finally {
    // setModalProps({ confirmLoading: true });
    // setModalProps({ confirmLoading: false });
    closeModal();
  }
}

function getSelectedTreeData(arr,selectedValues){
  let results: any[] = [];
  const filter = ((arr,curSelectedItem)=>{
    arr.map((item,index)=>{
      // Logger.log('item,',item,index)
      if(item?.children?.length>0){
        filter(item.children,curSelectedItem)
      }
      if(item.value===curSelectedItem){
        results.push(item)
      }
    })
  })
  selectedValues.map((curSelectedItem)=>{
    filter(arr,curSelectedItem);
  })
  return results;
}

// let selectedTreeData = [];
// function getSelectedTreeData2(arr,selectedValues){
//   let selectedTreeData = [];
//   const filter = ((arr)=>{
//     arr.map((item,index)=>{
//       // Logger.log('item,',item,index)
//       if(item?.children?.length>0){
//         filter(item.children)
//       }
//       if(selectedValues.includes(item.value)){
//         selectedTreeData.push(item)
//       }
//     })
//   })
//   filter(arr);
//   return selectedTreeData;
// }
</script>

<style lang="less" scoped>

</style>
